#!/usr/bin/env python
# Converts adblock lists to a format usable for surfAdblock

import re
import sys

allitems = {}
#if len(sys.argv) <= 1:
#	print('%s <filename>' % (sys.argv[0]))
#	exit(1)

#filename = sys.argv[1]
#lines = file(filename, 'r').readlines()

lines = sys.stdin.readlines()

for line in lines:
	line = line.strip()
	if line.startswith('!'):
		continue

	line     = re.sub('^@@', '', line)
	line     = re.sub('^\|\|', '', line)
	line     = re.sub('^[Adblock.*]', '', line)

	splline  = line.split('##')
	sites    = splline[0]
	selector = ''.join(splline[1:])

	if sites and selector:
		sites = sites.split(',')
	else:
		sites = ['global']

	# Try to extract the selector in some other format.
	if not selector:
		selector = line
		selector = re.sub('\$[~]?[a-z_\-]+.*', '', selector)
		selector = re.sub('\*|\^', '', selector)
		selector = '[src*="%s"],[href*="%s"]' % (selector, selector)

	if selector:
		for site in sites:
			site = site.strip()
			site = re.sub('^~', '', site)
			if not allitems.has_key(site):
				allitems[site] = []
			allitems[site].append(selector)

ordered = sorted(allitems.keys())
for k in ordered:
	v = allitems[k]
	print('%s\n\t%s\n' % (k, '\n\t'.join(v)))
